;
; Ext2Fsd (ext2 file system driver) setup configure for Inno Setup
;
; http://ext2fsd.sourceforge.net
;
; Created by:
;     Jared Breland <jbreland@legroom.net>
;
; Modified by:
;    Matt Wu <mattwu@163.com>
;

[Setup]
AppName=Ext2Fsd
AppVerName=Ext2Fsd
AppPublisher=Matt Wu
AppPublisherURL=http://ext2fsd.sourceforge.net/
AppSupportURL=http://ext2fsd.sourceforge.net/
AppUpdatesURL=http://ext2fsd.sourceforge.net/
DefaultDirName={pf}\Ext2Fsd
DefaultGroupName=Ext2Fsd
AllowNoIcons=true
OutputDir=C:\temp\Ext2Fsd\0.25
OutputBaseFilename=ext2fsd-0.25
Compression=lzma
SolidCompression=true
InternalCompressLevel=max
SourceDir=C:\temp\Ext2Fsd\0.25\Ext2Fsd
VersionInfoVersion=1.0
AllowUNCPath=false
DisableReadyPage=true
ShowLanguageDialog=auto
MinVersion=0,5.0.2195
OnlyBelowVersion=0,5.3
VersionInfoCompany=Jared Breland
AppVersion=2.5
VersionInfoDescription=Installer for linux ext2 file system driver (Ext2Fsd)
UninstallRestartComputer=true

[Files]
Source: Documents\*; DestDir: {app}\Documents; Flags: ignoreversion; Components: driver_all
Source: Setup\*; DestDir: {app}; Flags: ignoreversion; Components: driver_all
Source: Setup\w2k\ext2fsd.sys; DestDir: {sys}\Drivers; Components: driver_all; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2600; Flags: uninsrestartdelete promptifolder
Source: Setup\wxp\ext2fsd.sys; DestDir: {sys}\Drivers; Components: driver_all; MinVersion: 0,5.01.2600; OnlyBelowVersion: 0,5.3; Flags: uninsrestartdelete promptifolder
Source: Src\*; DestDir: {app}\Src; Flags: ignoreversion recursesubdirs createallsubdirs; Components: source
Source: Setup\Mke2fs.exe; DestDir: {sys}; Flags: ignoreversion
Source: Setup\Mount.exe; DestDir: {sys}; Flags: ignoreversion

[Icons]
; Name: {group}\Configure Ext2Fsd; Filename: {app}\ext2conf.exe; WorkingDir: {app}
Name: {group}\Ext2Fsd Documentation; Filename: {app}\Documents\

[Run]
; Filename: {app}\ext2conf.exe; Description: Configure Ext2Fsd; Flags: nowait postinstall skipifsilent; WorkingDir: {app}

[UninstallRun]
; Filename: {app}\ext2conf.exe; Parameters: /unmountall; WorkingDir: {app}; Flags: runhidden

[Types]
Name: cp_all; Description: Ext2fsd Driver (all codepages embeded) and Source Code; Flags: iscustom

[Components]
Name: driver_all; Description: Ext2Fsd drivers images ; ExtraDiskSpaceRequired: 1177; Flags: fixed; Types: cp_all
Name: source; Description: Ext2fsd source code; ExtraDiskSpaceRequired: 4433

[Tasks]
Name: auto_start; Description: Make Ext2Fsd automatically started when system boots; Flags: unchecked
Name: write; Description: Enable write support for Ext2 partitions; Flags: unchecked checkablealone
Name: write\ext3_write; Description: Enable force writing support on Ext3 partitions; Flags: unchecked dontinheritcheck

[Registry]
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: string; ValueName: DisplayName; ValueData: Linux ext2 File system driver; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: ErrorControl; ValueData: 00000001; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: string; ValueName: Group; ValueData: File System; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: expandsz; ValueName: ImagePath; ValueData: system32\DRIVERS\Ext2Fsd.sys; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: Start; ValueData: 00000001; Flags: uninsdeletekey; Tasks: auto_start
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: Start; ValueData: 00000003; Flags: uninsdeletekey; Tasks: not auto_start
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: Type; ValueData: 00000001; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: WritingSupport; ValueData: 00000000; Flags: uninsdeletekey; Tasks: not write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: WritingSupport; ValueData: 00000001; Flags: uninsdeletekey; Tasks: write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: CheckingBitmap; ValueData: 00000000; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: Ext3ForceWriting; ValueData: 00000000; Flags: uninsdeletekey; Tasks: not write\ext3_write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: Ext3ForceWriting; ValueData: 00000001; Flags: uninsdeletekey; Tasks:  write\ext3_write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: string; ValueName: CodePage; ValueData: default; Flags: uninsdeletekey
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Services\Eventlog\System\Ext2Fsd; ValueType: dword; ValueName: TypesSupported; ValueData: 00000007; Flags: uninsdeletevalue
Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Services\Eventlog\System\Ext2Fsd; ValueType: expandsz; ValueName: EventMessageFile; ValueData: %SystemRoot%\System32\IoLogMsg.Dll; Flags: uninsdeletevalue

[Code]
type
	SERVICE_STATUS = record
		dwServiceType		: cardinal;
	end;
	HANDLE = cardinal;

const
	SERVICE_ALL_ACCESS		= $f01ff;
	SC_MANAGER_ALL_ACCESS	= $f003f;
	SERVICE_START			= $10;

function CloseServiceHandle(hSCObject :HANDLE): boolean;
external 'CloseServiceHandle@advapi32.dll stdcall';

function OpenSCManager(lpMachineName, lpDatabaseName: string; dwDesiredAccess :cardinal): HANDLE;
external 'OpenSCManagerA@advapi32.dll stdcall';

function CreateService(hSCManager :HANDLE;lpServiceName, lpDisplayName: string;dwDesiredAccess,dwServiceType,dwStartType,dwErrorControl: cardinal;lpBinaryPathName,lpLoadOrderGroup: String; lpdwTagId : cardinal;lpDependencies,lpServiceStartName,lpPassword :string): cardinal;
external 'CreateServiceA@advapi32.dll stdcall';

function OpenService(hSCManager :HANDLE;lpServiceName: string; dwDesiredAccess :cardinal): HANDLE;
external 'OpenServiceA@advapi32.dll stdcall';

function StartNTService(hService :HANDLE;dwNumServiceArgs : cardinal;lpServiceArgVectors : cardinal) : boolean;
external 'StartServiceA@advapi32.dll stdcall';

function OpenServiceManager() : HANDLE;
begin
	if UsingWinNT() = true then begin
		Result := OpenSCManager('','ServicesActive',SC_MANAGER_ALL_ACCESS);
		if Result = 0 then
			MsgBox('the servicemanager is not available', mbError, MB_OK)
	end
	else begin
			MsgBox('only nt based systems support services', mbError, MB_OK)
			Result := 0;
	end
end;

function InstallService(FileName, ServiceName, DisplayName, Description : string; ServiceType,StartType : cardinal) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
begin
	hSCM 	:= OpenServiceManager();
	Result	:= false;
	if hSCM <> 0 then begin
		hService := CreateService(hSCM,ServiceName,DisplayName,SERVICE_ALL_ACCESS,ServiceType,StartType,1,FileName,'',0,'','','');
		if hService <> 0 then begin
			Result := true;
			// Win2K & WinXP supports aditional description text for services
			if Description <> '' then
				RegWriteStringValue(HKLM,'System\CurrentControlSet\Services\' + ServiceName,'Description',Description);
			CloseServiceHandle(hService)
		end;
		CloseServiceHandle(hSCM)
	end
end;

function StartService(ServiceName: string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
begin
	hSCM := OpenServiceManager();
	Result := false;
	if hSCM <> 0 then begin
		hService := OpenService(hSCM,ServiceName,SERVICE_START);
	    if hService <> 0 then begin
	    	Result := StartNTService(hService,0,0);
			CloseServiceHandle(hService)
		end;
	    CloseServiceHandle(hSCM)
	end;
end;

procedure MyInstallService();
begin
	InstallService('system32\Drivers\ext2fsd.sys', 'Ext2Fsd', 'Linux ext2 File system driver', '', 1, 1);
	StartService('Ext2Fsd');
end;

procedure CurStepChanged(CurStep: TSetupStep);
begin
	if CurStep = ssPostInstall then begin
		MyInstallService();
	end;
end;

